import { Component, EventEmitter, Input, Output } from '@angular/core';

@Component({
  selector: 'app-textarea',
  templateUrl: './textarea.component.html',
  styleUrls: ['./textarea.component.scss'],
})
export class TextareaComponent {
  /** HTML id associated with for */
  @Input({ required: true }) id: string;

  @Input() disabled = false;

  /** Label for the textarea */
  @Input() label?: string;

  /** Additional label description */
  @Input() description?: string;

  /** Max length of the input */
  @Input() maxLength = 500;

  /** The default number of rows to determine height of the area */
  @Input() nbRows = 8;

  /** What additional data should be displayed ? */
  @Input() status?: 'error' | 'success';

  /** Placeholder */
  @Input() placeholder?: string = '';

  /** Value */
  @Input() value = '';

  /** Is the textarea required ? */
  @Input() required = false;

  @Output() valueChange = new EventEmitter<string>();

  public onValueChange(): void {
    this.valueChange.emit(this.value);
  }
}
